<?php
/******************************************************************************
* TopicCount.php                                                              *
*******************************************************************************
* SMF: Simple Machines Forum                                                  *
* Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                *
* Software Version:           SMF 1.1.2+			                                *
* Software by:                DIN1031                                         *
* Copyright 2007 by:     			DIN1031											                    *
* Support, News, Updates at:  http://mods.simplemachines.org                  *
*******************************************************************************
* This program is free software; you may redistribute it and/or modify it     *
* under the terms of the provided license as published by SMF.                *
*                                                                             *
* This program is distributed in the hope that it is and will be useful,      *
* but WITHOUT ANY WARRANTIES; without even any implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
******************************************************************************/ 

if (!defined('SMF'))
	die('Hacking attempt...');

/*	
	TopicCount()
		- is accessed by ?action=topiccount;topic=ID_TOPIC.START.
		- load all datas for the Current List

	TopicCount_loadColors($users)
		- return loaded Colors
		- error return a false

	loadTopicCounter($ID_TOPIC = null)
		- load the context for the list
		- handle the cache rebuilt

	renewTopicCountData($ID_TOPIC = null)
		- Built the Post Count list $context without using the cache
	
	loadTopicCountChache($ID_TOPIC = null)
		- Built the Post Count list $context by using the cached table data
	
	renewTopicCountCache($ID_TOPIC = null)
		- Update the Post Count Chache
	
	builtTopicCountSort()
		- Built the gloabals $sort and $desc for this function
		- Built the $context['sort_info']
	
	loadTopicTeplies($ID_TOPIC = null, $reset = false)
		- Load the numReplies from the given Topic and store it in the $context['numreplies']
		- chache this data so that it only load on time
	
	builtTopicID($ID_TOPIC = null);
		- On ID_TOPIC is equal to null than the current $topic will be returned
		- die on empty $topic
	
	array_split($array = array(), $offset = 0, $limit = 0)
		- Split a array to a given $offset
		- return array('0' = array(...), '1' = array(''), ....)
		(Function load only if it not allready exists...)
*/

function TopicCount() {

	global $db_prefix, $topic, $txt, $context, $modSettings;

	if (empty($topic))
		fatal_lang_error(472, false);
	elseif($context['user']['is_guest'] && empty($modSettings['topiccountAllowGuests']))
		redirectexit();
	
	//First i will look if there is a Replies Limit set (Admins can see it even if a limit is set)
	if(!$context['user']['is_admin'] && !empty($modSettings['topiccountMaxRepliesLimit']) && $modSettings['topiccountMaxRepliesLimit'] > 0) {
		loadTopicReplies();
		if($context['numReplies'] > $modSettings['topiccountMaxRepliesLimit'])
			fatal_error($txt['threadcountlist_error'], false);
	}

	// Get the topic starter information.
	$request = db_query("
		SELECT m.subject as subject
		FROM {$db_prefix}messages AS m
		WHERE m.ID_TOPIC = $topic
		ORDER BY ID_MSG
		LIMIT 1", __FILE__, __LINE__);
	if (mysql_num_rows($request) == 0)
		fatal_lang_error('smf232');
	$row = mysql_fetch_assoc($request);
	mysql_free_result($request);

	$context['topic_subject'] = $row['subject'];

	loadTopicCounter();	

	// Lets "output" all that info.
	loadTemplate('TopicCount');
	$context['template_layers'] = array('TopicCount');
}

//This is  a small Skript to load colors for Thank You (a little bit faster... because sometime i need 100+ colors :x)
//Hmmmm i need to know how to chache large datas :x
function TopicCount_loadColors($users) {
	global $color_profile, $db_prefix, $modSettings;

	// Can't just look for no users :P.
	if (empty($users))
		return false;

	// Make sure it's an array.
	$users = !is_array($users) ? array($users) : array_unique($users);
	
	if (empty($users))
		return false;

	// Load the data.
	$request = db_query("
		SELECT 
		mem.ID_MEMBER AS ID_MEMBER, mem.realName AS realName,
		mg.onlineColor AS member_group_color, IFNULL(mg.groupName, '') AS member_group,
		pg.onlineColor AS post_group_color, IFNULL(pg.groupName, '') AS post_group
		FROM {$db_prefix}members AS mem 
			LEFT JOIN {$db_prefix}membergroups AS pg ON (pg.ID_GROUP = mem.ID_POST_GROUP)
			LEFT JOIN {$db_prefix}membergroups AS mg ON (mg.ID_GROUP = mem.ID_GROUP)
		WHERE mem.ID_MEMBER ".(count($users) == 1 ? " = '" . current($users) . "'" : " IN ('" . implode("', '", $users) . "')"), __FILE__, __LINE__);

	$loaded_ids = array();
	while ($row = mysql_fetch_assoc($request))
	{
		$loaded_ids[] = $row['ID_MEMBER'];
		$color_profile[$row['ID_MEMBER']] = $row;
	}
	mysql_free_result($request);

	return empty($loaded_ids) ? false : $loaded_ids;
}

function loadTopicCounter($ID_TOPIC = null) {
	global $context, $db_prefix, $modSettings;
	
	$ID_TOPIC = builtTopicID($ID_TOPIC);
	builtTopicCountSort();
	loadTopicReplies($ID_TOPIC);

	if(empty($modSettings['topiccountDisableTableCache'])) {

		if(empty($modSettings['topiccountTableCacheUpdate']))
			$modSettings['topiccountTableCacheUpdate'] = 0;
		else
			$modSettings['topiccountTableCacheUpdate'] = $modSettings['topiccountTableCacheUpdate'] * 60;

		//Small look if there some Datas in the cache :)
		$request = db_query("
			SELECT ID_TOPIC AS ID_TOPIC, ID_MEMBER AS ID_MEMBER, postcount as info
			FROM {$db_prefix}postcount_cache
			WHERE ID_TOPIC = $ID_TOPIC
				AND ID_MEMBER <= -10
			LIMIT 3", __FILE__, __LINE__);
		
		$context['postCountCacheInfo'] = array();
		
		while($row = mysql_fetch_assoc($request)) {
			if($row['ID_MEMBER'] == -11) 
				$context['postCountCacheInfo']['lastNumReplies'] = $row['info'];
			elseif($row['ID_MEMBER'] == -10)
				$context['postCountCacheInfo']['lastUpdate'] = $row['info'];
			else
				$context['postCountCacheInfo']['limit'] = $row['info'];
		}
		
		//First Time Built the cache?
		if(empty($context['postCountCacheInfo'])) {
			renewTopicCountCache($ID_TOPIC);
		}
		elseif($context['postCountCacheInfo']['lastNumReplies'] != $context['numReplies'] && (time() - $modSettings['topiccountTableCacheUpdate'] >= $context['postCountCacheInfo']['lastUpdate'])) {
		 	renewTopicCountCache($ID_TOPIC);
		}
		else
			loadTopicCountCache($ID_TOPIC);
	}
	else
		renewTopicCountData($ID_TOPIC);
	
	return;
}

function renewTopicCountData($ID_TOPIC = null) {
	global $context, $db_prefix, $sort, $desc, $modSettings, $txt, $ID_MEMBER, $scripturl;

	$ID_TOPIC = builtTopicID($ID_TOPIC);
		
	builtTopicCountSort();
	$context['count_list_members'] = array();
	$context['count_list_guests'] = array();
	$usersids = array();
	
	//Let's Load the info :D
	$request = db_query("
		SELECT count(*) AS MemberCounter, msg.ID_MEMBER AS ID_MEMBER, mem.realName AS realName
		FROM {$db_prefix}messages AS msg
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = msg.ID_MEMBER)
		WHERE ID_TOPIC = $ID_TOPIC
		AND msg.ID_MEMBER !=0
		GROUP BY msg.ID_MEMBER
		ORDER BY $sort $desc",__FILE__,__LINE__);
	
	while($row = mysql_fetch_assoc($request)) {
		$context['count_list_members'][] = array(
			'ID_MEMBER' => $row['ID_MEMBER'],
			'realName' => $row['realName'],
			'MemberCounter' => $row['MemberCounter'],
			'link' => '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $row['realName'] . '">' . $row['realName'] . '</a>',
			'isMember' => $ID_MEMBER == $row['ID_MEMBER'],
		);
		$usersids[] = $row['ID_MEMBER'];
	}

	mysql_free_result($request);

	//Do you like colors? (Insall the Member Color Link Mod for it!)
	if(!empty($modSettings['topiccountMemberColorLink']) && !empty($usersids)) {
		global $color_profile;
		TopicCount_loadColors($usersids);
		foreach($context['count_list_members'] as $key => $value) {
			$cid = $value['ID_MEMBER'];
			if(isset($color_profile[$cid]) && (!empty($color_profile[$cid]['member_group_color']) || !empty($color_profile[$cid]['post_group_color']))) {
				$profile = $color_profile[$cid];
				$context['count_list_members'][$key]['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';
			}
		}
	}

	//Okay now i will add a list of Guest :D
	//Let's Load the info :D
	$request = db_query("
		SELECT count(*) AS MemberCounter, msg.posterName AS realName
		FROM {$db_prefix}messages AS msg
		WHERE ID_TOPIC = $ID_TOPIC
		AND msg.ID_MEMBER = 0
		GROUP BY msg.posterName
		ORDER BY $sort $desc",__FILE__,__LINE__);
	
	while($row = mysql_fetch_assoc($request)) {
		$context['count_list_guests'][] = array(
			'realName' => $row['realName'],
			'MemberCounter' => $row['MemberCounter'],
		);
	}

	mysql_free_result($request);
	
	return true;
}

function loadTopicCountCache($ID_TOPIC = null) {
	global $context, $db_prefix, $sort, $desc, $modSettings, $txt, $ID_MEMBER, $scripturl;

	$ID_TOPIC = builtTopicID($ID_TOPIC);
	builtTopicCountSort();

	$context['count_list_members'] = array();
	$context['count_list_guests'] = array();
	$usersids = array();
	
	//Let's Load the info :D
	$request = db_query("
		SELECT pcc.postcount AS MemberCounter, pcc.ID_MEMBER AS ID_MEMBER, mem.realName AS realName
		FROM {$db_prefix}postcount_cache AS pcc
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = pcc.ID_MEMBER)
		WHERE ID_TOPIC = $ID_TOPIC
		AND pcc.ID_MEMBER > 0
		ORDER BY $sort $desc",__FILE__,__LINE__);
	
	while($row = mysql_fetch_assoc($request)) {
		$context['count_list_members'][] = array(
			'ID_MEMBER' => $row['ID_MEMBER'],
			'realName' => $row['realName'],
			'MemberCounter' => $row['MemberCounter'],
			'link' => '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $row['realName'] . '">' . $row['realName'] . '</a>',
			'isMember' => $ID_MEMBER == $row['ID_MEMBER'],
		);
		$usersids[] = $row['ID_MEMBER'];
	}

	mysql_free_result($request);

	//Do you like colors? (Insall the Member Color Link Mod for it!)
	if(!empty($modSettings['topiccountMemberColorLink']) && !empty($usersids)) {
		global $color_profile;
		TopicCount_loadColors($usersids);
		foreach($context['count_list_members'] as $key => $value) {
			$cid = $value['ID_MEMBER'];
			if(isset($color_profile[$cid]) && (!empty($color_profile[$cid]['member_group_color']) || !empty($color_profile[$cid]['post_group_color']))) {
				$profile = $color_profile[$cid];
				$context['count_list_members'][$key]['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';
			}
		}
	}

	//Okay now i will add a list of Guest :D
	//Let's Load the info :D
	$request = db_query("
		SELECT pcc.postcount AS MemberCounter, pcc.memberName AS realName
		FROM {$db_prefix}postcount_cache AS pcc
		WHERE ID_TOPIC = $ID_TOPIC
		AND pcc.ID_MEMBER = 0
		ORDER BY $sort $desc",__FILE__,__LINE__);
	
	while($row = mysql_fetch_assoc($request)) {
		$context['count_list_guests'][] = array(
			'realName' => $row['realName'],
			'MemberCounter' => $row['MemberCounter'],
		);
	}

	mysql_free_result($request);
	
	return true;
}

function renewTopicCountCache($ID_TOPIC = null) {
	global $context, $db_prefix, $modSettings;
	
	$ID_TOPIC = builtTopicID($ID_TOPIC);

	//Load the current Data :)
	renewTopicCountData($ID_TOPIC);
	
	//Store it in the Database :)
	loadTopicReplies($ID_TOPIC, true);
	$numReplies = $context['numReplies'];
	$lastUpdate = time();
	$limit = count($context['count_list_members']) + count($context['count_list_guests']);
	
	//I store it in some steps... and split it in more if to many user allready postet...
	$maxExecuteLimitPerQuery = (empty($modSettings['maxExecuteLimitPerQuery']) ? 1000 : $modSettings['maxExecuteLimitPerQuery']);

	db_query("
		DELETE FROM {$db_prefix}postcount_cache 
		WHERE ID_TOPIC = $ID_TOPIC", __FILE__, __LINE__);

	//Insert the Members	
	if(!empty($context['count_list_members'])) {
		$insert = array_split($context['count_list_members'], $maxExecuteLimitPerQuery);
		foreach($insert as $items) {
				$sql_insert = "
					INSERT INTO {$db_prefix}postcount_cache (ID_TOPIC, ID_MEMBER, memberName, postcount) VALUES";
			foreach($items as $item) {
				$sql_insert .= '
					('.$ID_TOPIC.', '.$item['ID_MEMBER'].', \''.mysql_escape_string($item['realName']).'\', '.$item['MemberCounter'].'),';
			}
			db_query(substr($sql_insert, 0, -1), __FILE__, __LINE__);
		}
	}	

	//Insert the Guests
	if(!empty($context['count_list_guests'])) {
		$insert = array_split($context['count_list_guests'], $maxExecuteLimitPerQuery);
		foreach($insert as $items) {
				$sql_insert = "
					INSERT INTO {$db_prefix}postcount_cache (ID_TOPIC, ID_MEMBER, memberName, postcount) VALUES";
			foreach($items as $item) {
				$sql_insert .= '
					('.$ID_TOPIC.', 0, \''.mysql_escape_string($item['realName']).'\', '.$item['MemberCounter'].'),';
			}
			db_query(substr($sql_insert, 0, -1), __FILE__, __LINE__);
		}
	}	
	//Last but not least the Cache infos ;D
	if(!empty($context['count_list_guests']) || !empty($context['count_list_members'])) 
		db_query("
			INSERT INTO {$db_prefix}postcount_cache (ID_TOPIC, ID_MEMBER, memberName, postcount) 
			VALUES
				($ID_TOPIC, -10, 'lastUpdate', $lastUpdate),
				($ID_TOPIC, -11, 'lastTopicCount', $numReplies),
				($ID_TOPIC, -12, 'LimitTopicCount', $limit)", __FILE__, __LINE__);

	//Yeah finishe build the Chache, now i output the allready stored info.
	return;
}

function builtTopicCountSort() {
	global $context, $sort, $desc;
	static $return;
	
	if(empty($return))
		$return = 1;
	else
		return true;
	
	$sort = '';
	$desc = '';	

	if(isset($_GET['sort']) && $_GET['sort'] == 'memberName') 
		$sort = 'realName';
	else
		$sort = 'MemberCounter';
	
	if(isset($_GET['desc']) && $sort == 'realName') 
		$desc = 'DESC';
	elseif(isset($_GET['desc']) && $sort == 'MemberCounter') 
		$desc = '';
	elseif(!isset($_GET['desc']) && $sort == 'MemberCounter') 
		$desc = 'DESC';
	else
		$desc = '';

	$context['sort_info'] = array($sort, $desc);
	
	return true;
}

function loadTopicReplies($ID_TOPIC = null, $reset = false) {
	global $context, $db_prefix;
	
	if(!empty($context['numReplies']) && !$reset)
		return true;
		
	$ID_TOPIC = builtTopicID($ID_TOPIC);
	
	//I need this for Caching :)
	$context['numReplies'] = 0;
	$request = db_query("SELECT numReplies FROM {$db_prefix}topics WHERE ID_TOPIC = $ID_TOPIC LIMIT 1", __FILE__, __LINE__);
	list($context['numReplies']) = mysql_fetch_row($request);
	mysql_free_result($request);
	
	return !empty($context['numReplies']);
}

function builtTopicID($ID_TOPIC = null) {
	global $topic;
	//Special Topic ;D
	if($ID_TOPIC === null)
		$ID_TOPIC = $topic;
	else 
		$ID_TOPIC = (int) $ID_TOPIC;

	if(empty($ID_TOPIC))
		fatal_lang_error(472, false);

	return $ID_TOPIC;
}

if(!function_exists('array_split')) {
	function array_split($array = array(), $offset = 0, $limit = 0)  {
	
		$offset = isset($offset) ? (int) $offset : 0;	
		$limit = isset($limit) ? (int) $limit : 0;	
		
		if(!is_array($array)) 
			trigger_error('array_split: First Value must be a Array', E_USER_ERROR);
		elseif(empty($offset))
			return array($array);
		
		$c = ceil(count($array) / $offset);
		
		$new_array = array();
		$x = 0;
		while($x < $c) {
			$new_array[] = array_slice($array, $x * $offset, $offset);
			$x++;
			if(!empty($limit) && $limit == $x)
				break;
		}
		
		return $new_array;
	}
}
?>
